from django.test import TestCase

# Create your tests here.
import datetime

from django.test import TestCase
from django.utils import timezone
from django.urls import reverse
from .models import Question

class QuestionModelTests(TestCase):

    def test_was_published_recently_with_future_question(self):
        time = timezone.now() + datetime.timedelta(days=30) #时间差，此处相当于加30天
        future_question = Question(pub_date=time)
        self.assertIs(future_question.was_published_recently(), False)

        def test_was_published_recently_with_old_question(self):
            time = timezone.now() - datetime.timedelta(days=1, seconds=1)
            old_question = Question(pub_date=time)
            self.assertIs(old_question.was_published_recently(), False)

        def test_was_published_recently_with_recent_question(self):
            time = timezone.now() - datetime.timedelta(hours=23, minutes=59, seconds=59)
            recent_question = Question(pub_date=time)
            self.assertIs(recent_question.was_published_recently(), True)
        # import datatime
        # >> > time2 = datetime.timedelta(seconds=23, minutes=35, hours=13)
        # datetime.timedelta(0, 48923)
        # >> > time3 = datetime.timedelta(seconds=23, minutes=35, hours=14)
        # datetime.timedelta(0, 52523)
        # >> > time3 - time2
        # datetime.timedelta(0, 3600)
        # 如果在编辑器中打印，则打印出
        # 1: 00:00

def create_question(question_text, days):
    time = timezone.now() + datetime.timedelta(days=days)
    return Question.objects.create(question_text=question_text, pub_date=time)

class QuestionDetailViewTests(TestCase):

    def test_future_question(self):
        future_question = create_question(question_text='Future question.', days=-5)
        url = reverse('polls:detail', args=(future_question.id,))
        response = self.client.get(url)
        self.assertEqual(response.status_code, 404)

    def test_past_question(self):
        past_question = create_question(question_text='Past Question.', days=5)
        url = reverse('polls:detail', args=(past_question.id,))
        print(url)
        response = self.client.get(url)
        print(response)
        # self.assertEqual(response.status_code, 404)
        self.assertContains(response, past_question.question_text)